
SQRT = math.sqrt
PI = math.pi
SIN = math.sin
COS = math.cos
FLOOR = math.floor
ABS = math.abs
CEIL = math.ceil
RAND = math.random
RAD = math.rad

math.randomseed( os.time() )


-- Requires ---------------------------
require("misclua.mathlib")
require("misclua.helpers")
require("misclua.coronahelpers")
json = require( "json" )
class = require("misclua.30log-global")
require("classes.Civilization")
require("classes.Planet")
require("classes.Star")
require("classes.Species")
require("classes.Ship")
require("classes.Galaxy")
---------------------------------------

--OLDER Spatial Definitions------------------------------------------
screenW = display.contentWidth
screenH = display.contentHeight
centerX  = display.contentWidth/2
centerY = display.contentHeight/2
---------------------------------------------------------------------

local data= {
	-- The width and height of the 
	-- galaxy in units. Pixels, light years, 
	-- hey it's up to you,
	-- Number of civilizations
	-- minimum distance from another civilization
	width = screenW,
	height = screenH,
	civilizations = 1,
	min_dist_from_civilizations = 200,
	max_dist_from_civilizations = 400,
}

-- local galaxy = Galaxy:new()
local galaxy = Galaxy:new(data)

local starModel = {}
local shipModel = {}

local starView = {}
local shipView = {}


function CreateModelStars()
	-- Run some tests on the galaxy object
	starModel = galaxy:GetAllStarsBelongingToACivilization(galaxy.civilizations[1])
	-- Debug info if you wanna verify stuff!
	-- for i=1,#starModel do
	-- 	print("Star "..starModel[i].name.." belongs to the "..galaxy.civilizations[1].name)
	-- end
end

function CreateModelShips()
	-- Create 25 ships and pass some data
	for i=1,25 do
		local shipData = {
			name = "Ship "..i,
			dockedAt = galaxy.stars[RAND(1,#galaxy.stars)],
			civilization = galaxy.civilizations[1],
			speed = RAND(1,10),
			heading = RAND(1,360)
		}

		local myShip = Ship:new(shipData)
		myShip.x,myShip.y = myShip.dockedAt.x,myShip.dockedAt.y
		table.insert(shipModel,myShip)
	end
end


CreateModelStars()
CreateModelShips()

function DisplayStars()
	-- Pick the colors outside the loop
	-- so they'll be the same for the 
	-- civilization
	local r = RAND(1,10)/10
	local g = RAND(1,10)/10
	local b = RAND(1,10)/10
	-- Iterate through our list of starModel
	-- to get the DATA ONLY to use to crate our
	-- View portion
	for i=1,#starModel do
		local tempStar = display.newCircle(starModel[i].x, starModel[i].y, 7 )
		tempStar:setFillColor( 1,1,1 )
		table.insert(starView,tempStar)
	end
	print("Size of StarView "..#starView)
end

function DisplayShips()
	-- Pick the colors outside the loop
	-- so they'll be the same for the 
	-- civilization
	local r = RAND(1,10)/10
	local g = RAND(1,10)/10
	local b = RAND(1,10)/10
	-- Iterate through our list of starModel
	-- to get the DATA ONLY to use to crate our
	-- View portion
	-- Create a ship next to each star in our
	-- starModel data
	for i=1,1 do
		-- Create a temporary ship display object
		-- Polypoints can be found in our misclua
		-- folder under corona helper. It makes n sided
		-- polygon display objects
		local tempShip = polypoints(6, RAND(5,7), 0.0,0)
		tempShip.id = i -- Assign it an id for down the road
		-- Sync up the x and y locations to be where our
		-- Starmodel[i]'s x and y location. Scoot it over
		-- 
		tempShip.x,tempShip.y = starModel[i].x+10,starModel[i].y
		shipModel[i].x,shipModel[i].y = tempShip.x,tempShip.y
  		table.insert(shipView,tempShip)
	end
	print("Size of shipView "..#shipView)
end

DisplayStars()
DisplayShips()
local move = true

function MoveShips()
	-- For now, let's just move ship 1
	-- Since we named them sequentially
	-- we know Ship 1 is in shipView[1]
	-- and that it's counterpart in the
	-- data model shipModel[1] too

	-- So, the actual functionality is
	-- built in to the OOP object in 
	-- shipModel, so let's make it find
	-- the heading for travel and then 
	-- move along the course.

		shipModel[1]:ChangeHeading(starModel[3])
		shipModel[1]:MoveForward()
		shipView[1].x,shipView[1].y = shipModel[1].x,shipModel[1].y
		print("Groovy")

end
starView[1]:setFillColor( 0,1,0 )
starView[3]:setFillColor( 1,0,0 )



timer.performWithDelay( 250, MoveShips,-1 )
